CON
  _clkmode = XTAL1+PLL16X
  _xinfreq = 5_000_000

OBJ
  rx: "x_rx"
  tx: "x_tx"
  
VAR
  long  storage[2]
  
PUB init | value

  dira := $00FF0003                                     ' output pins

  tx.init(@storage[0])                                  ' tx cogs
  rx.init(@storage[1])                                  ' rx cog

  repeat value from 0 to 255
    repeat while storage[0]                             ' wait for transmitter idle
    storage[0] := value << 9 | tx#cmdSEND               ' send byte
    repeat until storage[1]                             ' wait for data ready
    if ((storage[1] & $FF) <> value)                    ' validate data
      outa[16..23] := $3C                               ' failure
      repeat
    storage[1] := 0                                     ' clear receive buffer

  outa[16..23] := $C3                                   ' success
  repeat

DAT